﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private cCallbackModule As Object
	Private cEventName As String
	Private cLeft, cTop, cWidth, cHeight As Int
	Private cLeft_1, cTop_1, cWidth_2, cHeight_2 As Int
	Private cParent As Panel
	Private cTag As Object
	Private cScaleTextSize = 1 As Float
	Private cScaleTextColor = Colors.Black As Int
	Private cScaleBackgroundColor = Colors.White As Int
	Private cBoarderWidth = 5dip As Int
	Private cBoarderColor = Colors.Gray As Int
	Private cScaleIndexColor = Colors.Red As Int
	Private cVisibleScaleNumbers = 7 As Int
	Private cVisibleScaleNumbers_1 = Floor(cVisibleScaleNumbers / 2) As Int
	Private cScaleNumbers = 10 As Int
	Private cScaleSpace = 0 As Int
	Private cNumberOfScales = 3 As Int
	Private cNumberOfScales_2 = cNumberOfScales / 2 As Int
	Private ScrollPosition0 As Int
	
	Private cPosition = 0 As Double
	Private lblWidth, lblWidth_2 As Int
	Private pnlMeter, pnlScale As Panel
	Private cvsScale As Canvas
	Private hsvScale As HorizontalScrollView
End Sub

'Initializes the RotatingMeter object. 
'CallbackModule = calling module mostly Me
'EventName = generic name for the events
Public Sub Initialize(CallbackModule As Object, EventName As String)
	cCallbackModule = CallbackModule
	cEventName = EventName
End Sub

'This routine is used by the Designer if you add the RotatingMeter in the Designer
Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	cLeft = Base.Left
	cTop = Base.Top
	cWidth = Base.Width
	cHeight = Base.Height

	cScaleTextSize = cHeight / GetDeviceLayoutValues.Scale / 2
	cScaleTextColor = Lbl.TextColor
	cTag = Base.Tag
	
	cParent = Props.get("activity")
	
	pnlMeter = Base
	
	Init
End Sub

'This routine is needed if you want to add the RotatingMeter view in the code.
'Parent = parent view, can be a Panel or the Activity
'Left, Top, Width and Height properties of the RotatingMeter
'Example: 
'<Code>RotatingMeter1.Initialize(Me, "RotatingMeter1")
'RotatingMeter1.Show(Activity, 20dip, 20dip, 150dip, 48dip)</Code>
Public Sub Show(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int, Position As Double)
 	cLeft = Left
	cTop = Top
	cWidth = Width
	cHeight = Height
	
	cParent = Parent
	
	pnlMeter.Initialize("")
	cParent.AddView(pnlMeter, cLeft, cTop, cWidth, cHeight)
	cPosition = Position
	
	Init
End Sub

'Internal routine to initialize the ListBox.
Private Sub Init
	cLeft_1 = cBoarderWidth
	cTop_1 = cBoarderWidth
	cWidth_2 = cWidth - 2 * cBoarderWidth
	cHeight_2 = cHeight - 2 * cBoarderWidth
	
	If cScaleTextSize = 1 Then
		cScaleTextSize = cHeight / GetDeviceLayoutValues.Scale / 2
	End If
	
	pnlMeter.Color = cBoarderColor

	hsvScale.Initialize(100, "")
	pnlMeter.AddView(hsvScale, cLeft_1, cTop_1, cWidth_2, cHeight_2)
	hsvScale.Panel.Color = cScaleTextColor
	
	pnlScale.Initialize("pnlScale")
	pnlMeter.AddView(pnlScale, cLeft_1, cTop_1, cWidth_2, cHeight_2)
	pnlScale.Color = Colors.ARGB(0, 0, 0, 0)
	cvsScale.Initialize(pnlScale)
	setScaleIndexColor(cScaleIndexColor)
	
	lblWidth = hsvScale.Width / cVisibleScaleNumbers
	lblWidth_2 = lblWidth - 2 * cScaleSpace

	Dim jo = hsvScale As JavaObject
  jo.RunMethod("setHorizontalScrollBarEnabled", Array As Object (False))
		
	For j = 0 To cNumberOfScales - 1
		For i = 0 To cScaleNumbers - 1
			Dim lbl As Label
			lbl.Initialize("")
			lbl.TextSize = cScaleTextSize
			lbl.Text = i
			lbl.TextColor = cScaleTextColor
			lbl.Color = cScaleBackgroundColor
			lbl.Gravity = Gravity.CENTER
			hsvScale.Panel.AddView(lbl, j * cScaleNumbers * lblWidth + i * lblWidth + cScaleSpace, 0, lblWidth_2, hsvScale.Height)
		Next
	Next
	hsvScale.Panel.Width = cNumberOfScales * cScaleNumbers * lblWidth
	ScrollPosition0 = (cScaleNumbers * cNumberOfScales_2 * 2 - cVisibleScaleNumbers_1) * lblWidth
	
	setScalePosition(cPosition)
End Sub

'Sets the scale position
Public Sub setScalePosition(Position As Double)
	Dim pos As Float
	Dim width = cScaleNumbers * lblWidth As Int
	
	pos = ScrollPosition0 + Position * lblWidth
	If pos < width Then
		pos = pos + width * cNumberOfScales_2
		hsvScale.ScrollToNow(pos)
	End If
	If pos > width * (cNumberOfScales_2 + 1) Then
		pos = pos - width
		hsvScale.ScrollToNow(pos)
	End If
	
	hsvScale.ScrollPosition = pos
	DoEvents
End Sub

Private Sub pnlScale_Click
	' dummy routine to consume the events
End Sub

'Gets os sets the scale background color
Public Sub setScaleBackgroundColor(ScaleBackgroundColor As Int)
	cScaleBackgroundColor = ScaleBackgroundColor

	If hsvScale.IsInitialized = True Then
		hsvScale.Panel.Color = cScaleBackgroundColor
	End If
End Sub

Public Sub getScaleBackgroundColor As Int
	Return cScaleBackgroundColor
End Sub

'Gets os sets the boarder color
Public Sub setBoarderColor(BoarderColor As Int)
	cBoarderColor = BoarderColor
	
	If pnlMeter.IsInitialized = True Then
		pnlMeter.Color = cBoarderColor
	End If
End Sub

Public Sub getBoarderColor As Int
	Return cBoarderColor
End Sub

'Gets os sets the scale color
Public Sub setScaleTextColor(TextColor As Int)
	
	cScaleTextColor = TextColor
	
	If hsvScale.IsInitialized = True Then
		Dim i, j, k As Int
		For j = 0 To cNumberOfScales - 1
			For i = 0 To cScaleNumbers - 1
				k = j * cScaleNumbers + i
				Dim lbl As Label
				lbl = hsvScale.Panel.GetView(k)
				lbl.TextColor = cScaleTextColor
			Next
		Next
	End If
End Sub

Public Sub getScaleTextColor As Int
	Return cScaleTextColor
End Sub

'Gets os sets the scale index color
Public Sub setScaleIndexColor(ScaleIndexColor As Int)
	
	cScaleIndexColor = ScaleIndexColor
	
	If pnlScale.IsInitialized = True Then
		Dim pth As Path
		Dim dx = 0.1 * pnlScale.Height As Int
		Dim dy = 1.75 * dx As Int
		pth.Initialize(pnlScale.Width / 2 - dx, 0)
		pth.LineTo(pnlScale.Width / 2 + dx, 0)
		pth.LineTo(pnlScale.Width / 2, dy)
		cvsScale.DrawPath(pth, cScaleIndexColor, True, 1)
		pth.Initialize(pnlScale.Width / 2 - dx, pnlScale.Height)
		pth.LineTo(pnlScale.Width / 2, pnlScale.Height - dy)
		pth.LineTo(pnlScale.Width / 2 + dx, pnlScale.Height)
		cvsScale.DrawPath(pth, cScaleIndexColor, True, 1)
		cvsScale.DrawLine(pnlScale.Width / 2, 0, pnlScale.Width / 2, pnlScale.Height, cScaleIndexColor, 1dip)
	End If
End Sub

Public Sub getScaleIndexColor As Int
	Return cScaleIndexColor
End Sub

'Sets os gets the scale text size
Public Sub setScaleTextSize(ScaleTextSize As Int)

	cScaleTextSize = ScaleTextSize
	
	If hsvScale.IsInitialized = True Then
		Dim i, j, k As Int
		For j = 0 To cNumberOfScales - 1
			For i = 0 To cScaleNumbers - 1
				k = j * cScaleNumbers + i
				Dim lbl As Label
				lbl = hsvScale.Panel.GetView(k)
				lbl.TextSize = cScaleTextSize
			Next
		Next
	End If
End Sub

Public Sub getScaleTextSize As Int
	Return cScaleTextSize
End Sub

'Sets or gets the Left property of the RotatingMeter
Public Sub setLeft(Left As Int)
	cLeft = Left
	pnlMeter.Left = cLeft
End Sub

Public Sub getLeft As Int
	Return cLeft
End Sub

'Sets or gets the Top property of the RotatingMeter
Public Sub setTop(Top As Int)
	cTop = Top
	pnlMeter.Top = cTop
End Sub

Public Sub getTop As Int
	Return cTop
End Sub

'Sets or gets the Width property of the RotatingMeter
Public Sub setWidth(Width As Int)
	cWidth = Width
	pnlMeter.Width = cWidth
End Sub

Public Sub getWidth As Int
	Return cWidth
End Sub

'Sets or gets the Height property of the RotatingMeter
Public Sub setHeight(Height As Int)
	cHeight = Height
	pnlMeter.Height = cHeight
End Sub

Public Sub getHeight As Int
	Return cHeight
End Sub

'Sets or gets the Tag property of the RotatingMeter
Public Sub setTag(Tag As Object)
	cTag = Tag
	pnlMeter.Tag = cTag
End Sub

Public Sub getTag As Object
	Return cTag
End Sub

'Removes the RotatingMeter
Public Sub RemoveView
	pnlMeter.RemoveView
End Sub

'Sets or gets the Visible property of the RotatingMeter
Public Sub setVisible(Visible As Boolean)
	pnlMeter.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return pnlMeter.Visible
End Sub

